import {isDef, isRegExp, remove} from '@/utils/util' // 引入util.js中的方法 isDef 是否定义 isRegExp 是否正则 remove 删除数组中的某个元素
const patternTypes = [String, RegExp, Array] // 定义 patternTypes 数组 里面的元素是 String RegExp Array

function matches (pattern, name) { // 判断 pattern 是否是 name 的子集
  if (Array.isArray(pattern)) { // 如果 pattern 是数组
    if (pattern.indexOf(name) > -1) { // 如果 name 在 pattern 数组中
      return true // 返回 true
    } else { // 如果 name 不在 pattern 数组中
      for (let item of pattern) { // 遍历 pattern 数组
        if (isRegExp(item) && item.test(name)) { // 如果 item 是正则 并且 item.test(name) 返回 true
          return true // 如果 item 是正则 并且 item.test(name) 返回 true 则返回 true
        }
      }
      return false // 如果 item 不是正则 或者 item.test(name) 返回 false 则返回 false
    }
  } else if (typeof pattern === 'string') { // 如果 pattern 是字符串
    return pattern.split(',').indexOf(name) > -1 // 返回 pattern.split(',') 数组中是否包含 name
  } else if (isRegExp(pattern)) { // 如果 pattern 是正则
    return pattern.test(name) // 返回 pattern.test(name)
  }
  /* istanbul ignore next */
  return false
}

function getComponentName (opts) { // 获取组件名称
  return opts && (opts.Ctor.options.name || opts.tag) // 返回 opts.Ctor.options.name 或者 opts.tag
}

function getComponentKey (vnode) {  // 获取组件的 key
  const {componentOptions, key} = vnode // 获取 vnode 的 componentOptions 和 key
  return key == null // 如果 key 不存在
    ? componentOptions.Ctor.cid + (componentOptions.tag ? `::${componentOptions.tag}` : '') 
    // 返回 componentOptions.Ctor.cid + (componentOptions.tag ? `::${componentOptions.tag}` : '')
    : key + componentOptions.Ctor.cid
    // 返回 key + componentOptions.Ctor.cid
}

function getFirstComponentChild (children) { // 获取第一个子组件
  if (Array.isArray(children)) { // 如果 children 是数组
    for (let i = 0; i < children.length; i++) { // 遍历 children
      const c = children[i] // 获取 children[i]
      if (isDef(c) && (isDef(c.componentOptions) || c.isAsyncPlaceholder)) { 
        // 如果 c 存在 并且 (c.componentOptions 存在 或者 c.isAsyncPlaceholder 存在)
        return c // 返回 c
      }
    }
  }
}

function pruneCache (keepAliveInstance, filter) { // 删除缓存
  const { cache, keys, _vnode } = keepAliveInstance // 获取 keepAliveInstance 的 cache keys _vnode
  for (const key in cache) { // 遍历 cache
    const cachedNode = cache[key] // 获取 cache[key]
    if (cachedNode) { // 如果 cachedNode 存在
      const name = getComponentName(cachedNode.componentOptions) // 获取组件名称
      const componentKey = getComponentKey(cachedNode) // 获取组件的 key
      if (name && !filter(name, componentKey)) { // 如果 name 存在 并且过滤器返回 false
        pruneCacheEntry(cache, key, keys, _vnode) // 删除缓存
      }
    }
  }
}

function pruneCacheEntry2(cache, key, keys) { // 删除缓存 2
  const cached = cache[key]  // 获取 cache[key]
  if (cached) { // 如果 cached 存在
    cached.componentInstance.$destroy() // 销毁组件
  } 
  cache[key] = null // 将 cache[key] 设置为 null
  remove(keys, key) // 删除 keys 中的 key
}

function pruneCacheEntry (cache, key, keys, current) { // 删除缓存
  const cached = cache[key] // 获取 cache[key]
  if (cached && (!current || cached.tag !== current.tag)) { // 如果 cached 存在 并且 (!current || cached.tag !== current.tag)
    cached.componentInstance.$destroy() // 销毁组件
  }
  cache[key] = null // 将 cache[key] 设置为 null
  remove(keys, key) // 删除 keys 中的 key
}

export default {
  name: 'AKeepAlive', // 组件名称 AKeepAlive
  abstract: true, // 抽象组件
  model: { // model
    prop: 'clearCaches', // 支撑 clearCaches
    event: 'clear',  // 触发 clear 事件
  },
  props: { // 支撑的属性
    include: patternTypes,  // 包含的组件
    exclude: patternTypes, // 排除的组件
    excludeKeys: patternTypes, // 排除的 key
    max: [String, Number], // 最大缓存数
    clearCaches: Array // 清除缓存
  },
  watch: { // 监听
    clearCaches: function(val) { // 监听 clearCaches
      if (val && val.length > 0) { // 如果 val 存在 并且 val.length > 0
        const {cache, keys} = this // 获取 cache keys
        val.forEach(key => { // 遍历 value
          pruneCacheEntry2(cache, key, keys) // 删除缓存
        }) 
        this.$emit('clear', []) // 触发 clear 事件
      }
    }
  },

  created() {
    this.cache = Object.create(null)
    this.keys = []
  },

  destroyed () {
    for (const key in this.cache) {
      pruneCacheEntry(this.cache, key, this.keys)
    }
  },

  mounted () {
    this.$watch('include', val => {
      pruneCache(this, (name) => matches(val, name))
    })
    this.$watch('exclude', val => {
      pruneCache(this, (name) => !matches(val, name))
    })
    this.$watch('excludeKeys', val => {
      pruneCache(this, (name, key) => !matches(val, key))
    })
  },

  render () {
    const slot = this.$slots.default
    const vnode = getFirstComponentChild(slot)
    const componentOptions = vnode && vnode.componentOptions
    if (componentOptions) {
      // check pattern
      const name = getComponentName(componentOptions)
      const componentKey = getComponentKey(vnode)
      const { include, exclude, excludeKeys } = this
      if (
        // not included
        (include && (!name || !matches(include, name))) ||
        // excluded
        (exclude && name && matches(exclude, name)) ||
        (excludeKeys && componentKey && matches(excludeKeys, componentKey))
      ) {
        return vnode
      }

      const { cache, keys } = this
      const key = vnode.key == null
        // same constructor may get registered as different local components
        // so cid alone is not enough (#3269)
        ? componentOptions.Ctor.cid + (componentOptions.tag ? `::${componentOptions.tag}` : '')
        : vnode.key + componentOptions.Ctor.cid
      if (cache[key]) {
        vnode.componentInstance = cache[key].componentInstance
        // make current key freshest
        remove(keys, key)
        keys.push(key)
      } else {
        cache[key] = vnode
        keys.push(key)
        // prune oldest entry
        if (this.max && keys.length > parseInt(this.max)) {
          pruneCacheEntry(cache, keys[0], keys, this._vnode)
        }
      }

      vnode.data.keepAlive = true
    }
    return vnode || (slot && slot[0])
  }
}
